JUCE: AudioParameterBool Class Reference

JUCE

Public Member Functions | Protected Member Functions | List of all members
AudioParameterBool Class Reference
juce_audio_processors » utilities

Provides a class of AudioProcessorParameter that can be used as a boolean value. More...

`#include <juce_AudioParameterBool.h>`

Inheritance diagram for AudioParameterBool:

## Public Member Functions
| AudioParameterBool (const ParameterID &parameterID, const String &parameterName, bool defaultValue, const AudioParameterBoolAttributes &attributes={})
| Creates a AudioParameterBool with the specified parameters. More...
| AudioParameterBool (const ParameterID &parameterID, const String &parameterName, bool defaultValue, const String &parameterLabel, std::function< String(bool value, int maximumStringLength)> stringFromBool=nullptr, std::function< bool(const String &text)> boolFromString=nullptr)
| Creates a AudioParameterBool with the specified parameters. More...
| ~AudioParameterBool () override
| Destructor. More...
bool | get () const noexcept
| Returns the parameter's current boolean value. More...
| operator bool () const noexcept
| Returns the parameter's current boolean value. More...
AudioParameterBool & | operator= (bool newValue)
| Changes the parameter's current value to a new boolean. More...
const NormalisableRange< float > & | getNormalisableRange () const override
| Returns the range of values that the parameter can take. More...
Public Member Functions inherited from RangedAudioParameter
virtual const NormalisableRange< float > & | getNormalisableRange () const =0
| Returns the range of values that the parameter can take. More...
int | getNumSteps () const override
| Returns the number of steps for this parameter based on the normalisable range's interval. More...
float | convertTo0to1 (float v) const noexcept
| Normalises and snaps a value based on the normalisable range. More...
float | convertFrom0to1 (float v) const noexcept
| Denormalises and snaps a value based on the normalisable range. More...
| AudioProcessorParameterWithID (const ParameterID &parameterID, const String &parameterName, const AudioProcessorParameterWithIDAttributes &attributes={})
| The creation of this object requires providing a name and ID which will be constant for its lifetime. More...
| AudioProcessorParameterWithID (const ParameterID &parameterID, const String &parameterName, const String &parameterLabel, Category parameterCategory=AudioProcessorParameter::genericParameter)
| The creation of this object requires providing a name and ID which will be constant for its lifetime. More...
Public Member Functions inherited from AudioProcessorParameterWithID
| AudioProcessorParameterWithID (const ParameterID &parameterID, const String &parameterName, const AudioProcessorParameterWithIDAttributes &attributes={})
| The creation of this object requires providing a name and ID which will be constant for its lifetime. More...
| AudioProcessorParameterWithID (const ParameterID &parameterID, const String &parameterName, const String &parameterLabel, Category parameterCategory=AudioProcessorParameter::genericParameter)
| The creation of this object requires providing a name and ID which will be constant for its lifetime. More...
String | getName (int) const override
| Returns the name to display for this parameter, which should be made to fit within the given string length. More...
String | getLabel () const override
| Some parameters may be able to return a label string for their units. More...
Category | getCategory () const override
| Returns the parameter's category. More...
String | getParameterID () const override
| Returns an ID that is unique to this parameter. More...
bool | isMetaParameter () const override
| Should return true if this parameter is a "meta" parameter. More...
bool | isAutomatable () const override
| Returns true if the host can automate this parameter. More...
bool | isOrientationInverted () const override
| This can be overridden to tell the host that this parameter operates in the reverse direction. More...
Public Member Functions inherited from HostedAudioProcessorParameter
virtual String | getParameterID () const =0
| Returns an ID that is unique to this parameter. More...
| AudioProcessorParameter () noexcept=default
| AudioProcessorParameter (int versionHint)
| The version hint supplied to this constructor is used in Audio Unit plugins to aid ordering parameter identifiers when JUCE_FORCE_USE_LEGACY_PARAM_IDS is not enabled. More...
Public Member Functions inherited from AudioProcessorParameter
| AudioProcessorParameter () noexcept=default
| AudioProcessorParameter (int versionHint)
| The version hint supplied to this constructor is used in Audio Unit plugins to aid ordering parameter identifiers when JUCE_FORCE_USE_LEGACY_PARAM_IDS is not enabled. More...
virtual | ~AudioProcessorParameter ()
| Destructor. More...
virtual float | getValue () const =0
| Called by the host to find out the value of this parameter. More...
virtual void | setValue (float newValue)=0
| The host will call this method to change the value of a parameter. More...
void | setValueNotifyingHost (float newValue)
| A processor should call this when it needs to change one of its parameters. More...
void | beginChangeGesture ()
| Sends a signal to the host to tell it that the user is about to start changing this parameter. More...
void | endChangeGesture ()
| Tells the host that the user has finished changing this parameter. More...
virtual float | getDefaultValue () const =0
| This should return the default value for this parameter. More...
virtual String | getName (int maximumStringLength) const =0
| Returns the name to display for this parameter, which should be made to fit within the given string length. More...
virtual String | getLabel () const =0
| Some parameters may be able to return a label string for their units. More...
virtual int | getNumSteps () const
| Returns the number of steps that this parameter's range should be quantised into. More...
virtual bool | isDiscrete () const
| Returns whether the parameter uses discrete values, based on the result of getNumSteps, or allows the host to select values continuously. More...
virtual bool | isBoolean () const
| Returns whether the parameter represents a boolean switch, typically with "On" and "Off" states. More...
virtual String | getText (float normalisedValue, int) const
| Returns a textual version of the supplied normalised parameter value. More...
virtual float | getValueForText (const String &text) const =0
| Should parse a string and return the appropriate value for it. More...
virtual bool | isOrientationInverted () const
| This can be overridden to tell the host that this parameter operates in the reverse direction. More...
virtual bool | isAutomatable () const
| Returns true if the host can automate this parameter. More...
virtual bool | isMetaParameter () const
| Should return true if this parameter is a "meta" parameter. More...
virtual Category | getCategory () const
| Returns the parameter's category. More...
int | getParameterIndex () const noexcept
| Returns the index of this parameter in its parent processor's parameter list. More...
virtual String | getCurrentValueAsText () const
| Returns the current value of the parameter as a String. More...
virtual StringArray | getAllValueStrings () const
| Returns the set of strings which represent the possible states a parameter can be in. More...
int | getVersionHint () const
void | addListener (Listener *newListener)
| Registers a listener to receive events when the parameter's state changes. More...
void | removeListener (Listener *listener)
| Removes a previously registered parameter listener. More...
void | sendValueChangedMessageToListeners (float newValue)

## Protected Member Functions
virtual void | valueChanged (bool newValue)
| Override this method if you are interested in receiving callbacks when the parameter value changes. More...

## Additional Inherited Members
Public Types inherited from AudioProcessorParameter
enum | Category { genericParameter = (0 << 16) | 0 , inputGain = (1 << 16) | 0 , outputGain = (1 << 16) | 1 , inputMeter = (2 << 16) | 0 , outputMeter = (2 << 16) | 1 , compressorLimiterGainReductionMeter = (2 << 16) | 2 , expanderGateGainReductionMeter = (2 << 16) | 3 , analysisMeter = (2 << 16) | 4 , otherMeter = (2 << 16) | 5 }
Public Attributes inherited from AudioProcessorParameterWithID
const String | paramID
| Provides access to the parameter's ID string. More...
const String | name
| Provides access to the parameter's name. More...
const String | label
| Provides access to the parameter's label. More...
const Category | category
| Provides access to the parameter's category. More...

## Detailed Description

Provides a class of AudioProcessorParameter that can be used as a boolean value.

See also
  AudioParameterFloat, AudioParameterInt, AudioParameterChoice

## Constructor & Destructor Documentation

## ◆ AudioParameterBool() [1/2]

AudioParameterBool::AudioParameterBool | ( | const ParameterID & | parameterID,
|  | const String & | parameterName,
|  | bool | defaultValue,
|  | const AudioParameterBoolAttributes & | attributes = `{}`
| ) |  |

Creates a AudioParameterBool with the specified parameters.

Note that the attributes argument is optional and only needs to be supplied if you want to change options from their default values.

Example usage:

auto attributes = AudioParameterBoolAttributes().withStringFromValueFunction ([] (auto x, auto) { return x ? "On" : "Off"; })
.withLabel ("enabled");
auto param = std::make_unique<AudioParameterBool> ("paramID", "Parameter Name", false, attributes);
AudioParameterBoolAttributes
Properties of an AudioParameterBool.
Definition: juce_AudioParameterBool.h:34
RangedAudioParameterAttributes::withStringFromValueFunction
JUCE_NODISCARD auto withStringFromValueFunction(StringFromValue x) const
An optional lambda function that converts a non-normalised value to a string with a maximum length.
Definition: juce_RangedAudioParameter.h:53
gl::x
GLdouble x
Definition: juce_gl.h:940
gl::param
GLenum GLfloat param
Definition: juce_gl.h:647

Parameters

  parameterID | The parameter ID to use
  parameterName | The parameter name to use
  defaultValue | The default value
  attributes | Optional characteristics

## ◆ AudioParameterBool() [2/2]

AudioParameterBool::AudioParameterBool | ( | const ParameterID & | parameterID,
|  | const String & | parameterName,
|  | bool | defaultValue,
|  | const String & | parameterLabel,
|  | std::function< String(bool value, int maximumStringLength)> | stringFromBool = `nullptr`,
|  | std::function< bool(const String &text)> | boolFromString = `nullptr`
| ) |  |

Creates a AudioParameterBool with the specified parameters.

Parameters

  parameterID | The parameter ID to use
  parameterName | The parameter name to use
  defaultValue | The default value
  parameterLabel | An optional label for the parameter's value
  stringFromBool | An optional lambda function that converts a bool value to a string with a maximum length. This may be used by hosts to display the parameter's value.
  boolFromString | An optional lambda function that parses a string and converts it into a bool value. Some hosts use this to allow users to type in parameter values.

## ◆ ~AudioParameterBool()

AudioParameterBool::~AudioParameterBool | ( |  | ) |
| override

Destructor.

## Member Function Documentation

## ◆ get()

bool AudioParameterBool::get | ( |  | ) | const
| noexcept

Returns the parameter's current boolean value.

References gl::value.

## ◆ operator bool()

AudioParameterBool::operator bool | ( |  | ) | const
| noexcept

Returns the parameter's current boolean value.

References dsp::get().

## ◆ operator=()

AudioParameterBool & AudioParameterBool::operator= | ( | bool | newValue | ) |

Changes the parameter's current value to a new boolean.

## ◆ getNormalisableRange()

const NormalisableRange< float > & AudioParameterBool::getNormalisableRange | ( |  | ) | const
| overridevirtual

Returns the range of values that the parameter can take.

Implements RangedAudioParameter.

References gl::range.

## ◆ valueChanged()

virtual void AudioParameterBool::valueChanged | ( | bool | newValue | ) |
| protectedvirtual

Override this method if you are interested in receiving callbacks when the parameter value changes.

The documentation for this class was generated from the following file:

- juce_AudioParameterBool.h